/* $Id: homingmissile.hpp,v 1.5.4.1 2006/01/20 11:33:52 chfreund Exp $ */

#ifndef _HOMINGMISSILE_HPP_
#define _HOMINGMISSILE_HPP_

/**********************************************************/

#include <iostream>
#include "missile.hpp"

/**********************************************************/

//! Homing Missile
class HomingMissile : public Missile
{
	friend class WeaponHomingMissile;

	public:
	
		HomingMissile();

		//! overwritten from class Missile
		bool initialize( const Vector& pos,
		                 const Vector& vel,
		                 const Uint8   owner,
		                 const Sint32  nShrapnels,
		                 const Sint32  damage,
		                 const Vector& thrust );

		//! overwritten from class Object
		virtual Sint32 getID() const { return HOMING_MISSILE; }

		virtual void update();
		virtual void explode( void );

		void updateSpriteSelection( const bool activeEngine );

		virtual void dump( std::ostream& out ) const;

	protected:
};

/**********************************************************/

#endif // _HOMINGMISSILE_HPP_
