/* $Id: random.cpp,v 1.12 2005/10/11 15:54:24 chfreund Exp $ */

#include "random.hpp"

#include "serialize.hpp"
#include <time.h>
#include <unistd.h>

/* Original MWC code by George Marsaglia */

Random::Random( const unsigned int seed ) :
		m_z( 362436069 ),
		m_w( 521288629 ),
		m_counter( 0 ) {
	const unsigned int N = (seed > 0 ? seed : ( clock() + getpid() ) & 0xffff);

	for( unsigned int i = 0; i < N; i++ ) getUint32();
}

Uint32 Random::getSerializeBufferSize() const {
	return Serialize<Uint32>::sizeOf( m_z ) +
		Serialize<Uint32>::sizeOf( m_w ) +
		Serialize<Uint32>::sizeOf( m_counter );
}

void Random::serialize( Uint8*& bufferPointer ) const {
	START_SERIALIZED_SIZE_CHECK( bufferPointer );
	
	Serialize<Uint32>::serialize( m_z, bufferPointer );
	Serialize<Uint32>::serialize( m_w, bufferPointer );
	Serialize<Uint32>::serialize( m_counter, bufferPointer );
	
	END_SERIALIZED_SIZE_CHECK( bufferPointer, Random );
}

void Random::deserialize( Uint8*& bufferPointer ) {
	Serialize<Uint32>::deserialize( bufferPointer, m_z );
	Serialize<Uint32>::deserialize( bufferPointer, m_w );
	Serialize<Uint32>::deserialize( bufferPointer, m_counter );
}

Random localRnd;
